
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java.sql.SQLException: 无效的列索引 / 憋错料</title>

    <meta name="description" content="java.sql.SQLException: 无效的列索引 “无效的列索引”其实是个低级的错误,原因无非几个: 1.sql串的?号数目和提供的变量数目不一致: 例如:jdbcTemplate.update(sql, new Object[] {newState,oldState}); 如果sql里面有1个?号,Object[]送了2个,就会报错. 2.sql串里的?号书写不正确 英文?和中文?有时难以区分. 3.sql串的?号用''括了起来. 例如:sql=&quot;UPDATE abc SET abc.name='?' WHERE abc.id='? ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">java.sql.SQLException: 无效的列索引</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>&ldquo;无效的列索引&rdquo;其实是个低级的错误，原因无非几个：</p>
<p>1、sql串的?号数目和提供的变量数目不一致：</p>
<p>例如：jdbcTemplate.update(sql, new Object[] {newState,oldState});</p>
<p>如果sql里面有1个?号，Object[]送了2个，就会报错。</p>
<p>2、sql串里的?号书写不正确</p>
<p>英文?和中文？有时难以区分。</p>
<p>3、sql串的?号用‘‘括了起来。</p>
<p>例如：sql="UPDATE abc SET abc.name=‘?‘ WHERE abc.id=‘?‘";</p>
<p>把‘‘去掉就可以了。</p>
<p>4，遇到这种情况select*from user where&nbsp;&nbsp; info&nbsp;&nbsp; like&nbsp;&nbsp; %?%;</p>
<p>虽然这是sql的写法，但是在jdbc 中需要改成 select*from user where&nbsp;&nbsp; info&nbsp;&nbsp; like&nbsp;&nbsp; ?;</p>
<p>如ps.setString(&ldquo;%&rdquo;+value+&ldquo;%&rdquo;);</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 08:05:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>java.sql.SQLException: 无效的列索引的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLOG9W4.html" rel="bookmark">java&period;sql&period;SQLException&colon; 无效的列类型&colon; 1111</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用Mybaits Plus更新数据时报错: 2018-09-05 10:55:40.712 DEBUG 15828 --- [nio-8110-exec-1] c.c.x.s.m.A.updateAllColumnById : ==&gt; Preparing: UPDATE ais0060 SET TENANT_ID=?,LIFNR=?,NAME1=?,ORT01=?,TELF1=?,del_flag=?,remarks=?,create_by=?,create_date=?,update_by			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q0xAbB3.html" rel="bookmark">mybatis查询oracle &rsquo;无效的列索引&OpenCurlyQuote;和ORA-00911&rsquo;无效的字符&OpenCurlyQuote;错误</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Caused by: java.sql.SQLException: 无效的列索引 参考文献:http://bbs.csdn.net/topics/300179772 配置的sql语句写错了 select distinct '#{pkgName}' as pkgName, '#{appName}' as appName, version as versionName from stat_dim_version where appkey=#{appKey} order by version de			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0enqm53.html" rel="bookmark">JFinal ActiveRecordException&colon; 无效的列索引</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				代码: Db.update(&quot;delete from T_Xabc where ID= '?'&quot;,&quot;9900&quot;); 现象: com.jfinal.plugin.activerecord.ActiveRecordException: java.sql.SQLException: 无效的列索引 at com.jfinal.plugin.activerecord.DbPro.update(DbPro.java:279) at com.jfinal.plugin.activ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0djyb94.html" rel="bookmark">【错误笔记】MyBatis SQLException&colon; 无效的列类型&colon; 1111</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述: org.springframework.jdbc.UncategorizedSQLException: Error setting null for parameter #1 with JdbcType OTHER . Try setting a different JdbcType for this parameter or a different jdbcTypeForNull configuration property. Cause: java.sql.SQLExceptio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j1xZ7M.html" rel="bookmark">java&period;sql&period;SQLException&colon; 索引中丢失  IN 或 OUT 参数&colon;&colon; 1解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java.sql.SQLException: 索引中丢失  IN 或 OUT 参数:: 1 at oracle.jdbc.driver.DatabaseError.throwSqlException(DatabaseError.java:125) at oracle.jdbc.driver.DatabaseError.throwSqlException(DatabaseError.java:162) at oracle.jdbc.driver.OraclePreparedStatement.pr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02ynLaM.html" rel="bookmark">java&period;sql&period;SQLException&colon; ORA-00911&colon; 无效字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天写一个查询SQL的时候,出现了&quot;java.sql.SQLException: ORA-00911: 无效字符&quot;的问题,各种百度问题找答案,说是SQL语句中多了不该有的符号.我的是多了分号,因为SQL语句在PL/SQL中试过没问题,就直接复制粘贴过来用了,结果,底层SQL语句不能有分号 错误代码如下: 然后控制台就报了如下错误: 把红色方框里面的分号去掉,然后就没有错误了.哎,写代码小细节贼多.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0b5bBLM.html" rel="bookmark">java连接sqlserver2008报错 java&period;sql&period;SQLException&colon; 对象名 &amp;&num;39&semi;表名&amp;&num;39&semi; 无效&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				注意:c3p0的数据库配置方式为: &lt;named-config name=&quot;sqlsvr&quot;&gt; &lt;property name=&quot;driverClass&quot;&gt;net.sourceforge.jtds.jdbc.Driver&lt;/property&gt; &lt;property name=&quot;jdbcUrl&quot;&gt;jdbc:jtds:sqlserver://localhost:1433/WaterNet_DaFeng&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bLRZw4.html" rel="bookmark">java&period;sql&period;SQLException&colon; 索引中丢失 IN或OUT 参数&colon;&colon;x</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用JDBC时,会有这么一个错误:java.sql.SQLException: 索引中丢失 IN或OUT 参数::x 如下示例中insertLog.execute();这行会抛出这个异常: String logSQL = &quot;insert into tbl_obj(id, obj, type, cont, proposer, operator, date, remark) &quot; + &quot;values(seq_tot.nextval, ?, ?, ?, ?, ?, SYSDATE,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pgaBo3.html" rel="bookmark">java&period;sql&period;SQLException&colon; Column &amp;&num;39&semi;class&amp;&num;39&semi; not found&period;异常没有找到列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 /**处理当个对象的 ,rs中要么有一条,要么一条没有. 2 * @param &lt;T&gt; 3 */ 4 public class BeanHandler&lt;T&gt; implements ResultSetHandler&lt;T&gt; { 5 private Class&lt;T&gt; type; 6 public BeanHandler(Class&lt;T&gt; type){ 7 this.type = type; 8 } 9 /**将rs-&gt;T t 10 */ 11			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AZRgM.html" rel="bookmark" class="title">虚拟机centOS中安装Redis&comma;主机Redis Destop Manager不能访问虚拟机Redis server的解决方案</a>
					<div>
						今天在学些redis的时候碰到个问题,发现主机Redis Destop Manager不能访问虚拟机Redis server的解决方案,找了一些网上的资料,原因可能有两个,整理记录下来: 1. Red ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyYXb3.html" rel="bookmark" class="title">HTTP权威指南-基础知识</a>
					<div>
						1.URL,URI 统一资源标识符?统一标识定位符? 2.http,https,ftp http://&lt;host&gt;:&lt;port&gt;/&lt;path&gt;/?&lt;query ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDWkB0.html" rel="bookmark" class="title">高性能mysql主主架构</a>
					<div>
						A.环境描述 服务器A(主) 192.168.0.105 服务器B(主) 192.168.0.108 Mysql版本: 5.6.21 System OS:CentOS release 6.5 主从需同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eAvxg0.html" rel="bookmark" class="title">NEFU118 n&excl;后面有多少个0【算术基本定理】</a>
					<div>
						题目链接: http://acm.nefu.edu.cn/JudgeOnline/problemshow.php?problem_id=118 题目大意: 问:计算N!末尾0的个数.(1 &lt;=  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APrkZ3.html" rel="bookmark" class="title">阻止事件冒泡（stopPropagation和cancelBubble）</a>
					<div>
						&lt;div id=&quot;divId1&quot; style=&quot;width:500px;height:500px;background-color:#3ac;text-align: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQgvB3.html" rel="bookmark" class="title">Redis 通信协议</a>
					<div>
						本文和大家分享的主要是redis 通信协议相关内容,一起来看看吧,希望对大家 学习redis有所帮助. 几乎所有的主流编程语言都有Redis 的客户端,不考虑 Redis 非常流行的原因,如果站在技术 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXyNb3.html" rel="bookmark" class="title">SQL入门经典&lpar;五&rpar; 之键和约束</a>
					<div>
						这一篇博客主要讲键的创建,约束的创建.修改对象和删除对象. 主键:主键是每行的唯一标识符,必须包含唯一值(因此不能为NULL).由于主键在关系中数据库的重要性,因此它是所有键和约束中最重要的.一个表最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRnJEM.html" rel="bookmark" class="title">Swoole</a>
					<div>
						Swoole Laravel如何优雅的使用Swoole 背景 正在做一个智能家居的项目(钱低的吓死人怎么办),接收下位机(就是控制智能家居硬件模块的HUB)协议解析,Web端维护硬件状态,利用APP交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AR52dM.html" rel="bookmark" class="title">Java集合框架&lpar;三&rpar;</a>
					<div>
						 Map Map集合:该集合存储键值对,一对一对的往里存,而且要保证键的唯一性. Map |------HashTable:底层是哈希表数据结构,不可以存入null键null值.该集合是线程同步的.J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wymgZM.html" rel="bookmark" class="title">select超链接跳转A</a>
					<div>
						客户端页面 实现 下拉菜单 跳转链接 如图 遂使用 select option来展现.开始想到添加 a标签,结果,不行.渲染不出来 搜索查询得知 如下方法实现 ================== & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomK1b3.html" rel="bookmark" class="title">安卓图表引擎AChartEngine&lpar;一&rpar; - 简介</a>
					<div>
						AChartEngine 是一个安卓系统上制作图表的框架,目前它支持如下的图表类型: line chart (折线图) area chart (面积图:分区图,对比图) scatter chart ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgNeJR4.html" rel="bookmark" class="title">Docker--------registry安全认证搭建 &lbrack; Https &rsqb;</a>
					<div>
						1. 背景     docker中要使用镜像,一般会从本地.docker Hup公共仓库和其它第三方公共仓库中下载镜像,一般出于安全和外网(墙)资源下载速率的原因考虑企业级上不会轻易使用.那么有没有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wOxZ0.html" rel="bookmark" class="title">Cocos2d-x基础知识</a>
					<div>
						本人在Visual Studio 2013用C++编写.运行时如果出现中文乱码,可在HelloWorldScene.cpp中加入 #pragma execution_character_set(&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NGB2GM.html" rel="bookmark" class="title">基于mysql的数据管理</a>
					<div>
						准备工作 注意   mysqldump.exe是MySQL数据库服务器的导出数据工具(登录对应mysql.exe) 1.数据备份 将数据库服务器中的数据保存在本地的SQL文件中 语法 mysqldum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7Z8v4.html" rel="bookmark" class="title">java连接redis</a>
					<div>
						类似于java连接mysql需要包 java连接redis同样也需要包 jedis-2.1.0.jar是java用来连接redis的包 1.将包引入即可 2. public void redisTes ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7Pqg4.html" rel="bookmark" class="title">在代码中设置TextView 的字体颜色</a>
					<div>
						常用的两种方法: 1.在res文件夹下的dimens.xml .styles.xml 或者strings.xml文件中添加&lt;color name = &quot;green&quot;&gt;# ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm98KVM.html" rel="bookmark" class="title">stl 之 next&lowbar;permutation 求出一个排序的下一个排列的函数 转载</a>
					<div>
						这是一个求一个排序的下一个排列的函数,可以遍历全排列,要包含头文件&lt;algorithm&gt;下面是以前的笔记    与之完全相反的函数还有prev_permutation  (1) int 类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjwjj3.html" rel="bookmark" class="title">WinForm中Component Class、User Control及Custom Control的区别和使用-转</a>
					<div>
						转http://www.cnblogs.com/jhtchina/archive/2010/11/28/1028591.html NET Framework 为您提供了开发和实现新控件的能力.除了常见 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2Boo0.html" rel="bookmark" class="title">阿里云 经典网络使用ClassicLink连接到专用网络后，192&period;168网段需要添加路由</a>
					<div>
						配置后,专用网络中的机器Ping不通经典网络, 查帮助说192.168网段需要手动添加路由表. 抓包能在经典网络中收到专用网络中过来的数据包,但回复的数据包不能正确发出去. 先用 route -n 查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZpNLZM.html" rel="bookmark" class="title">为 Neutron 准备物理基础设施（II） - 每天5分钟玩转 OpenStack（76）</a>
					<div>
						本节将按照上一节的规划安装配置控制节点和计算节点. 控制节点 devstack-controller 步骤如下 安装 Ubuntu 14.04 此处省略 256 个字 配置网卡 编辑 /etc/net ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
